// from Cousot Halbwachs POPL 78 paper, with bug added

// infer sufficient conditions on N to prove that there is no array overflow;
// due to the bug, an error occurs when the inner loop is executed;
// we find N <= 0 as a sufficient condition, which ensures that the inner
// loop is never executed (but the outter loop may be executed once)

// note that the forward analysis finds no condition on N, although it
// only keeps the traces that do not fail 

integer J,N,B,T;

void main()
{
  B = N + 1;     // BUG, should be B = N
  /* {1} */
  while (B>=1) {
    /* {2} */
    J = 1; 
    T = 0;
    /* {3} */
    while (J <= B-1) {
      /* {4} */
      // models "if (k[J]>K[J+1])" with error checking
      assert(J>=1 && J<=N && J+1>=1 && J+1<=N);
      if ([0;1]==1) {
        /* {5} */
        //exchange(J,J+1);
        /* {6} */
        T = J;
        /* {7} */
      }
      /* {8} */
      J++;
      /* {9} */
    }
    /* {10} */
    if (T==0) return;
    /* {11} */
    B = T;
    /* {12} */
  }
  /* {13} */
}
