// from Cousot Halbwachs POPL 78 paper

// for N >= 10, we find as sufficient precondition that N >= 18
// (removing both asserts at {15} and {17}, we get N >= 10)

// if lower bound of N < 9, we find _|_ 

// NOTE: without any preconditin on N, the _forward_ analysis is very slow

integer N = [10;1000];

void main()
{
  integer L,R,I,J;
  /* {1} */
  L = (N / 2) + 1;
  R = N;
  /* {2} */
  if (L >= 2) {
    /* {3} */
    L--;
    assert(L >= 1 && L <= N);
    /* {4} */
  }
  else {
    /* {5} */
    assert(R >= 1 && R <= N && 1 <= N);
    R--;
    /* {6} */
  }
  /* {7} */
  while (R >= 2) {
    /* {8} */
    I = L;
    J = 2*I;
    /* {9} */
    while (J <= R) {
      /* {10} */
      if (J <= R-1) {
        /* {11} */
        assert(J >= 1 && J+1 <= N);
        if ([0;1]==0) { J++; } 
      }
      /* {12} */
      assert(J >= 1 && J <= N);
      if ([0;1]==0) break;
      /* {13} */
      assert(I >= 1 && I <= N && J >= 1 && J <= N);
      I = J;
      J = 2*J;
      /* {14} */
    }
    /* {15} */
    assert(I >= 1 && I <= N);
    /* {6} */
    if (L >= 2) {
      /* {17} */
      L--;
      assert(L >= 1 && L <= N);
      /* {18} */
    }
    else {
      /* {19} */
      assert(R >= 1 && R <= N && 1 <= N);
      R--;
      /* {20} */
    }
    /* {21} */
    assert(1 <= N);
    /* {22} */
  }
  /* {23} */
}
